///////////////////////////////////////////////////////////////////////////
/// Fichero: derivada_publica.h                        
///           
/// Contenido: definicion de una clase derivada publica     
///
/// Ultima modificacion: 14/noviembre/2009                    
///////////////////////////////////////////////////////////////////////////


#ifndef _DERIVADA_PUBLICA_H_
#define _DERIVADA_PUBLICA_H_

///////////////////////////////////////////////////////////////////////////
///
/// Clase: Derivada_publica                                                  
/// Descripcion:                                                        
///               Representa a una clase que hereda de forma publica 
///               de la clase Base
/// Representacion:                                                      
///              a: publico
///              _b: protegido
///              _c: privado
/// Herencia: hereda de forma publica de la clase Base      
///                        
///////////////////////////////////////////////////////////////////////////


class Derivada_Publica: public Base
{

  public:
  
     int a;

    /// Constructor con todos los argumentos con valores por defecto.
    Derivada_Publica(int dato_publico = 0, int dato_protegido = 0, int dato_privado = 0,
                     int dato_a = 0, int dato_b = 0, int dato_c = 0): 
    /// Se usa el constructor de la clase base como iniciador
          Base(dato_publico,dato_protegido,dato_privado)
    {
      a = dato_a;
      _b = dato_b;
      _c = dato_c;
    }; 

    /// Funciones de consulta de los atributos "no" publicos

    int get_B() {return _b; };

    int get_C() {return _c; };

    void ver_Derivada_Publica()
    {
      cout << " Atributos propios de la clase derivada publica " << endl;
      cout << " a (publico): " << a << endl;
      cout << " _b (protegido): " << _b << endl;
      cout << " _c (privado): " << _c << endl << endl;

      cout << " Atributos heredados de la clase base" << endl;
      cout << " publico: " << publico << endl;
      cout << " _protegido: " << _protegido << endl;
      cout << " _privado:  " << get_Privado() 
           << " --> usando la funcion de consulta de la clase base dentro de la clase publica " << endl;

     // La clase derivada no puede acceder directamente al atributo privado de la clase base
     // ERROR --->  cout << " privado: " << _privado << endl << endl; 

     };

    /// Funciones de modificacion para los atributos "no" publicos

   /// 
    void set_B(int dato_b) { _b = dato_b; }; 

   ///  
    void set_C(int dato_c) { _c = dato_c; }

   
  /// Funcion que modifica los atributos heredados y propios
   void set_Derivada_Publica(int dato_publico, int dato_protegido, int dato_privado,
                     int dato_a, int dato_b, int dato_c) 
    {
      publico = dato_publico;
      _protegido = dato_protegido;

      /// _privado = dato_privado; // --->  ERROR: No accesible
      set_Privado(dato_privado);      

     /// Propios
      a = dato_a;
      _b = dato_b;
      _c = dato_c;
    }; 


  
  protected:
       int _b;
        
  private:

       int _c;
};
   
#endif 
